$regfile = "m328pdef.dat"                         ' ATmega328.
$crystal = 16000000                               ' 16 .
$hwstack = 128
$swstack = 200
$framesize = 200

Config Base = 0                                   '     .
Config Submode = New

Outpin Alias Portb.3                              '  .  Arduino   D11.

Config Outpin = Output
Outpin = 0

Const F_setting = 0                               '         .

Const Cp_min = 2                                  '     (   0).
Const Cp_max = 140                                '     (  154).
Const Press_min = -8                              '    ( 0.1 mm.Hg).
Const Press_max = 700                             '    ( 0.1 mm.Hg).

' .
Dim T0_counter As Byte                            '    Timer0.
Dim T0_temp As Byte
Dim Event_100ms As Byte                           '   131 .
Dim Event_500ms As Byte                           '   655 .
Dim Event_1s As Byte                              '   1049 .
Dim Int_detect As Byte                            '       .

Dim Setpoint_pressure As Byte                     '  .
Dim Sensor_calibration As Word                    '    .
Dim Maxpower_rh As Word                           '   .

Dim Flags As Byte                                 ' .  f_xxxx.
Dim Current_pressure As Integer                   '     0.1 mm.Hg
Dim Current_pow As Byte                           '            .

$include "PID.bas"
$include "Key.bas"
$include "Logic.bas"
$include "Setting.bas"

Config Clockdiv = 1                               '    .

Config Lcd = 16x2                                 '   2   16   .
Config Lcdbus = 4
Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portb.1 , Rs = Portb.0

Config Adc = Single , Prescaler = Auto , Reference = Avcc       '  .

Config Timer0 = Timer , Prescale = 1024           '   16 ,  61   .
On Timer0 T0                                      '     Timer0.
Enable Timer0                                     '    Timer0.

Config Timer2 = Timer , Prescale = 1024
Stop Timer2
Timer2 = 0
Compare2a = 250
Compare2b = 20
On Oc2a T2_ca
Enable Oc2a
On Oc2b T2_cb
Enable Oc2b


Config Int0 = Rising                              '    .
On Int0 Int_0
Enable Int0


Read_setting                                      '     .

Int_detect = 1
Current_pressure = 0
Current_pow = 2

Enable Interrupts                                 '  .


Config Watchdog = 4096                            '      4 .
Reset Watchdog
Start Watchdog

Cls                                               '  .
Cursor Off , Noblink

Lcd "Initialization"


Do
   Reset Watchdog

   If Event_100ms = 1 Then
     Event_100ms = 0
     'Get_press                                    '    .

     Current_pressure = Calc_press()              '     0.1 mm.Hg.
     Current_pow = Calc_power(current_pressure , Setpoint_pressure)
     Set_power Current_pow


     If Flags.f_setting = 0 Then                  '    .
       Key_to_setting                             '    Button_select     .
     Else
       Setting_menu                               '  .
     End If
   End If

   If Event_500ms = 1 Then
     Event_500ms = 0
     If Flags.f_setting = 0 Then                  '   ( ).
       Display_workinfo                           '        .
     End If
   End If

   If Event_1s = 1 Then
     Event_1s = 0

'     Current_pressure = Calc_press()              '     0.1 mm.Hg.
'     Current_pow = Calc_power(current_pressure , Setpoint_pressure)
'     Set_power Current_pow

'     If Flags.f_setting = 0 Then                  '   ( ).
'       Display_workinfo                           '        .
'     End If

   End If

   Idle                                           '       .
Loop



T0:                                               '    Timer0 (61   ).

  Incr T0_counter

  T0_temp = T0_counter And 7

  If T0_temp = 0 Then
    Event_100ms = 1                               '   131 .
  End If

  If T0_counter = 32 Then
    Event_500ms = 1
  End If

  If T0_counter = 64 Then
    T0_counter = 0
    Event_500ms = 1
    Event_1s = 1                                  '   1049 .
  End If

Return


T2_ca:
  Outpin = 1
Return

T2_cb:
  Outpin = 0
  Stop Timer2
Return

Int_0:
  Stop Timer2
  Outpin = 0
  Timer2 = 0
  Tifr2 = &B00000111
  Start Timer2
  Int_detect = 0
Return