$nocompile

Const Time_to_setting = 20                        '    ( 0.1 .)     .
Const Time_out_setting = 200                      '  ( 0.1 .)         ,    .

Const Sp_min = 0.1                                '    PID .
Const Sp_max = 40                                 '    PID .

Const Sf_main_menu = 0                            '  (1)    .

'  .
Const Menu_count = 4                              '    (   0).
Const Mi_pressure = 0                             '  ,   .
Const Mi_power_rh = 1                             '  ,    .
Const Mi_pid = 2                                  '   PID .
Const Mi_calibration = 3                          '  ( 0)  .
Const Mi_exit = 4                                 '   .

'   .
Dim Count_setting As Byte                         '       .
Dim Menu_index As Byte                            '        .
Dim S_old_key As Byte                             '    .
Dim S_flags As Byte                               '  .
Dim S_param1 As Integer                           '   .
Dim S_param2 As Integer
Dim S_param3 As Integer
Dim S_index_x As Byte                             '      ,    .
Dim Slk_count As Byte                             '    .
Dim Slk_old As Byte                               '    .

Dim S_param_str As String * 10

'     EEPROM.
Dim Ee_press As Eram Byte                         '  .
Dim Ee_sensor_calibration As Eram Word            '    .
Dim Ee_maxpower As Eram Word                      '   .
Dim Ee_pid_igain As Eram Single                   '   .
Dim Ee_pid_pgain As Eram Single
Dim Ee_pid_dgain As Eram Single



Sub Read_setting()                                '     .

  Setpoint_pressure = Ee_press
  If Setpoint_pressure > 70 Then
     Setpoint_pressure = 20
  End If

  Sensor_calibration = Ee_sensor_calibration
  If Sensor_calibration > 800 Then
    Sensor_calibration = 36                       '  0.18    5.
  End If

  Maxpower_rh = Ee_maxpower
  If Maxpower_rh > 20000 Then
     Maxpower_rh = 1000
  End If

  Pid_igain = Ee_pid_igain
  If Pid_igain < Sp_min Or Pid_igain > Sp_max Then
    Pid_igain = 3                                 '.4
  End If

  Pid_pgain = Ee_pid_pgain
  If Pid_pgain < Sp_min Or Pid_pgain > Sp_max Then
    Pid_pgain = 2
  End If

  Pid_dgain = Ee_pid_dgain
  If Pid_dgain < Sp_min Or Pid_dgain > Sp_max Then
    Pid_dgain = 2
  End If

End Sub

Sub Menu_exit()                                   '   .
  Count_setting = 0
  Flags.f_setting = 0                             '    .
  Cursor Off , Noblink
  Display_workinfo
End Sub

Sub Wait_key_out_setting()                        '  ,        ,      .
  Local Key As Byte

  Key = Getkey()

  If Key = Button_none Then                       '     .
    Incr Count_setting
    If Count_setting >= Time_out_setting Then
      Menu_exit
    End If
  Else
    Count_setting = 0
  End If

End Sub

Sub Update_menu_item(index As Byte)               '    .

   Cursor Off , Noblink
   Locate 2 , 1

   Select Case Index
     Case Mi_pressure
       Lcd S_param1 ; " mm.Hg" ; Spc(10)
       Locate 2 , 1
     Case Mi_power_rh
       Lcd S_param1 ; " W" ; Spc(16)
       Locate 2 , 1
     Case Mi_pid
       S_param_str = Str(s_param1)
       Lcd "i" ; Format(s_param_str , "00.0")
       S_param_str = Str(s_param2)
       Lcd "p" ; Format(s_param_str , "00.0")
       S_param_str = Str(s_param3)
       Lcd "d" ; Format(s_param_str , "00.0")
       If S_index_x = 0 Then
         Locate 2 , 1
       Elseif S_index_x = 1 Then
         Locate 2 , 6
       Elseif S_index_x = 2 Then
         Locate 2 , 11
       End If
     Case Mi_calibration
       Lcd "    Yes   No    "
       If S_index_x = 0 Then
         Locate 2 , 5
       Elseif S_index_x = 1 Then
         Locate 2 , 11
       End If
   End Select

   Cursor Off , Blink
End Sub

Sub Show_menu_item(index As Byte)                 '   .

   Cursor Off , Noblink
   Lcd Index ; " "

   Select Case Index
     Case Mi_pressure
       Lcd "Pressure"
     Case Mi_power_rh
       Lcd "Power"
     Case Mi_pid
       Lcd "PID "
     Case Mi_calibration
       Lcd "Calibr sensor"
     Case Mi_exit
       Lcd "Exit menu"
   End Select

   Lcd Spc(10)
   Locate 1 , 1
   Cursor Off , Blink

End Sub

Sub Sub_menu_change_pid(byref Param As Integer , Key As Byte)
   If Key = Button_up Then
    If Param < 399 Then
      Incr Param
    End If
   Elseif Key = Button_down Then
    If Param > 2 Then
      Decr Param
    End If
   End If
End Sub


Sub Sub_menu_change(key As Byte , Index As Byte)

  Select Case Index
     Case Mi_pressure
        If Key = Button_up Then
          If S_param1 < 70 Then
            Incr S_param1
          End If
        Elseif Key = Button_down Then
          If S_param1 > 0 Then
            Decr S_param1
          End If
        End If
     Case Mi_power_rh
        If Key = Button_up Then
          S_param1 = S_param1 + 100
          If S_param1 > 20000 Then
             S_param1 = 20000
          End If
        Elseif Key = Button_down Then
          S_param1 = S_param1 - 100
          If S_param1 < 100 Then
            S_param1 = 100
          End If
        End If
     Case Mi_pid
        Select Case S_index_x
          Case 0
            Sub_menu_change_pid S_param1 , Key
          Case 1
            Sub_menu_change_pid S_param2 , Key
          Case 2
            Sub_menu_change_pid S_param3 , Key
        End Select
   End Select

   Update_menu_item Index

End Sub

Sub Sub_menu_posx(key As Byte , Index As Byte)
   Select Case Index
     Case Mi_pid
       If Key = Button_left Then
         If S_index_x > 0 Then
           Decr S_index_x
           Update_menu_item Index
         End If
       Elseif Key = Button_right Then
         If S_index_x < 2 Then
           Incr S_index_x
           Update_menu_item Index
         End If
       End If
     Case Mi_calibration
       If Key = Button_left Then
         If S_index_x > 0 Then
           Decr S_index_x
           Update_menu_item Index
         End If
       Elseif Key = Button_right Then
         If S_index_x < 1 Then
           Incr S_index_x
           Update_menu_item Index
         End If
       End If
   End Select
End Sub

Sub Save_info(index As Byte)
   Local Si As Byte
   'Local Sadc As Single

   Cursor Off , Noblink

   Select Case Index
     Case Mi_pressure
       If S_param1 <> Setpoint_pressure Then
         Setpoint_pressure = S_param1
         Ee_press = Setpoint_pressure
       End If
     Case Mi_power_rh
       If S_param1 <> Maxpower_rh Then
         Maxpower_rh = S_param1
         Ee_maxpower = Maxpower_rh
       End If
     Case Mi_pid
       Pid_igain = S_param1 / 10
       Pid_pgain = S_param2 / 10
       Pid_dgain = S_param3 / 10
       Ee_pid_igain = Pid_igain
       Ee_pid_pgain = Pid_pgain
       Ee_pid_dgain = Pid_dgain
     Case Mi_calibration

       If S_index_x = 0 Then
          Sensor_calibration = Getadc(1)
          Ee_sensor_calibration = Sensor_calibration

'          For Si = 0 To 200
'            If Event_1s = 1 Then                  '     .
'              Sadc = Adc_sensor_val / Adc_sensor_count
'              Sensor_calibration = Sadc
'              Ee_sensor_calibration = Sensor_calibration
'              Exit For
'            Else
'              Waitms 20
'            End If
'            Reset Watchdog
'          Next Si

'          If Si >= 200 Then
'            Cls
'            Lcd "Calibration err"
'            Reset Watchdog
'            Waitms 1000
'            Reset Watchdog
'          End If

       End If
   End Select

  S_flags.sf_main_menu = 1                        '    .
  Update_main_menu
End Sub

Sub Sub_menu(key As Byte)
  Local Lkey As Byte

  If S_old_key = Button_none Then

    If Key = Button_up Or Key = Button_down Then
       Sub_menu_change Key , Menu_index
    Elseif Key = Button_left Or Key = Button_right Then
       Sub_menu_posx Key , Menu_index
    Elseif Key = Button_select Then               '   Select.
       Save_info Menu_index
    End If

  End If

  Lkey = Long_down_key(slk_count , Slk_old , 16 , Key)

  '    .
  If Lkey = Button_up Or Lkey = Button_down Then
    Sub_menu_change Key , Menu_index
  End If

End Sub

Sub Update_main_menu()                            '    .
  Local Item2 As Byte

  Locate 1 , 1
  Show_menu_item Menu_index

  If Menu_index = Menu_count Then
    Item2 = 0
  Else
    Item2 = Menu_index + 1
  End If

  Locate 2 , 1
  Show_menu_item Item2
End Sub

Sub Select_menu(key As Byte)                      '    .

  If Key = Button_up Then
    If Menu_index > 0 Then
      Decr Menu_index
    Else
      Menu_index = Menu_count
    End If
  Elseif Key = Button_down Then
    If Menu_index < Menu_count Then
      Incr Menu_index
    Else
      Menu_index = 0
    End If
  End If

  Update_main_menu

End Sub

Sub Click_menu_item()                             '     (  Select).

   If Menu_index = Mi_exit Then                   '   .
     Menu_exit
   Else

     S_flags.sf_main_menu = 0                     '   .

     Locate 1 , 1
     Show_menu_item Menu_index
     Cursor Off , Noblink
     Locate 2 , 1

     Select Case Menu_index
       Case Mi_pressure
         S_param1 = Setpoint_pressure
       Case Mi_power_rh
         S_param1 = Maxpower_rh
       Case Mi_pid
         S_param1 = Pid_igain * 10
         S_param2 = Pid_pgain * 10
         S_param3 = Pid_dgain * 10
         S_index_x = 0
       Case Mi_calibration
         S_index_x = 1
     End Select

     Update_menu_item Menu_index

   End If
End Sub

Sub Setting_menu()                                '  .
  Local Key As Byte

  Key = Getkey()

  If S_flags.sf_main_menu = 1 Then                '  .

    If S_old_key = Button_none Then
      If Key = Button_up Or Key = Button_down Then
        Select_menu Key
      Elseif Key = Button_select Then
        Click_menu_item                           '     (  Select).
      End If
    End If

  Else                                            '   .
    Sub_menu Key
  End If

  S_old_key = Key

  Wait_key_out_setting                            '  ,        ,      .
End Sub

Sub Key_to_setting()                              '    Button_select     .
   Local Key As Byte

   Key = Getkey()

   If Key = Button_select Then
     Incr Count_setting
     If Count_setting >= Time_to_setting Then
       Count_setting = 0
       Menu_index = 0
       S_old_key = Key
       Flags.f_setting = 1                        '    .
       S_flags.sf_main_menu = 1                   '  .
       Slk_count = 0
       Slk_old = Button_none
       Cls                                        '  
       Update_main_menu
     End If
   Else
     Count_setting = 0
   End If
End Sub